/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>
#include <iterator>
#include <utility>

using namespace std;

vector<size_t> v[1002002];
size_t used[1002002] = {};

void dfs(size_t edge)
{
    size_t depth(1);
    for(size_t i = 0; i < v[edge].size(); ++i)
    {
        if(!used[v[edge][i]])
            dfs(v[edge][i]);
        if(used[v[edge][i]] >= depth)
            depth = used[v[edge][i]]+1;
    }
    used[edge] = depth;
}

int main(void)
{
    size_t n, last, tmp;
    ifstream in("graph.in");
    vector<size_t> v_e;
    in >> n;
    in.get();
    v_e.reserve(n*n);
    for(size_t i = 1; i <= n; ++i)
    {
        last = 0;
        while(in.peek() != '\n')
        {
            in >> tmp;
            if(i < tmp)
                v_e.push_back(i*1001 + tmp);
            if(last)
                v[i < last ? i*1001 + last : last*1001 + i].push_back(i < tmp ? i*1001 + tmp : tmp*1001 + i);
            last = tmp;
        }
        in.get();
    }
    in.close();
    for(size_t i = 0; i < v_e.size(); ++i)
        if(!used[v_e[i]])
            dfs(v_e[i]);
    vector<pair<size_t, size_t> > ans(v_e.size());
    for(size_t i = 0; i < v_e.size(); ++i)
        ans[i] = make_pair(used[v_e[i]], v_e[i]);
    sort(ans.begin(), ans.end(), greater<pair<size_t, size_t> >());
    ofstream out("graph.out");
    for(size_t i = 0; i < ans.size(); ++i)
        out << ans[i].second / 1001 << ' ' << ans[i].second % 1001 << endl;
    out.close();
    return 0;
}
